diff -r -u -H -N gcc-2.6.3/config/i386/i386.h gcc-i2.6.3/config/i386/i386.h
--- gcc-2.6.3/config/i386/i386.h	Wed Oct 19 16:52:09 1994
+++ gcc-i2.6.3/config/i386/i386.h	Wed Feb 15 23:07:40 1995
@@ -1,5 +1,8 @@
-/* Definitions of target machine for GNU compiler for Intel X86 (386, 486, pentium)
-   Copyright (C) 1988, 1992, 1994 Free Software Foundation, Inc.
+/* Definitions of target machine for GNU compiler for Intel X86.
+   Copyright (C) 1988, 1992 Free Software Foundation, Inc.
+
+   Pentium cpu support and other enhancements by Tevi Devor Intel Corp.
+   (tevi@iil.intel.com).
 
 This file is part of GNU CC.
 
@@ -54,6 +57,50 @@
 /* Run-time compilation parameters selecting different hardware subsets.  */
 
 extern int target_flags;
+/* Which processor to schedule for. intel1 */
+
+enum processor_type {
+  PROCESSOR_DEFAULT,
+  PROCESSOR_386,
+  PROCESSOR_486,
+  PROCESSOR_PENTIUM
+};
+extern enum processor_type x86_cpu;	/* which cpu are we scheduling for */
+
+/* intel1 */
+#define REDUCE_INDEX (TARGET_486 || TARGET_PENTIUM)
+#define SAVE_ON_REGS 1
+#define MAX_DEST_ADDR_GIVS 5
+#define PREFER_JUMP_NOT_TAKEN 1
+#define PREFER_CONST_IN_REG 1
+#define IGNORE_NON_DATA_DEP 1
+#define STORE_NOT_SET_CC0 1
+#define NO_CROSS_JUMP_ON_LOOP_ENTRY 1
+#define AGI 1
+/* #define SPILL1 */
+#define EXPENSIVE_OPS(x) \
+   ( GET_CODE(x)==MULT ? \
+       ((GET_CODE (XEXP (x, 1)) == CONST_INT && \
+	exact_log2 (INTVAL (XEXP (x, 1))) >= 0) ? 0 : 1) : \
+	(GET_CODE(x)==DIV || GET_CODE(x)==UDIV || \
+	 GET_CODE(x)==MOD || GET_CODE(x)==UMOD ))
+
+#define NO_STACK_REG_REORDER (!TARGET_PENTIUM)
+
+#define STACK_REG_REORDER \
+	((TARGET_PENTIUM) && reload_completed == 0 && flag_schedule_stack_reg_insns)
+
+#define STACK_NON_STACK_INTERLEAVE \
+	(reload_completed == 0 && flag_interleave_stack_non_stack)
+	
+#define IS_RISC_MODE(mode) (((mode) == QImode || (mode) == SImode))
+
+/* Number of extra pseudo registers we allocate for so that reg-stack
+   can replace fld's and fstps with movs
+*/
+#define SPARE_REGS 5
+#define OVERRIDE_OPTIONS override_options()
+
 
 /* Macros used in the machine description to test the flags.  */
 
@@ -62,142 +109,106 @@
 #define TARGET_CPU_DEFAULT 0
 #endif
 
-/* Masks for the -m switches */
-#define MASK_80387		000000000001	/* Hardware floating point */
-#define MASK_486		000000000002	/* 80486 specific */
-#define MASK_NOTUSED		000000000004	/* bit not currently used */
-#define MASK_RTD		000000000010	/* Use ret that pops args */
-#define MASK_REGPARM		000000000020	/* Pass args in eax, edx */
-#define MASK_SVR3_SHLIB		000000000040	/* Uninit locals into bss */
-#define MASK_IEEE_FP		000000000100	/* IEEE fp comparisons */
-#define MASK_FLOAT_RETURNS	000000000200	/* Return float in st(0) */
-#define MASK_NO_FANCY_MATH_387	000000000400	/* Disable sin, cos, sqrt */
-
-						/* Temporary codegen switches */
-#define MASK_DEBUG_ADDR		000001000000	/* Debug GO_IF_LEGITIMATE_ADDRESS */
-#define MASK_NO_WIDE_MULTIPLY	000002000000	/* Disable 32x32->64 multiplies */
-#define MASK_NO_MOVE		000004000000	/* Don't generate mem->mem */
-
-/* Use the floating point instructions */
-#define TARGET_80387 (target_flags & MASK_80387)
-
+/* Compile 80387 insns for floating point (not library calls).  */
+#define TARGET_80387 (target_flags & 1)
 /* Compile using ret insn that pops args.
    This will not work unless you use prototypes at least
    for all functions that can take varying numbers of args.  */  
-#define TARGET_RTD (target_flags & MASK_RTD)
-
+#define TARGET_RTD (target_flags & 8)
 /* Compile passing first two args in regs 0 and 1.
    This exists only to test compiler features that will
    be needed for RISC chips.  It is not usable
    and is not intended to be usable on this cpu.  */
-#define TARGET_REGPARM (target_flags & MASK_RTD)
+#define TARGET_REGPARM (target_flags & 020)
 
 /* Put uninitialized locals into bss, not data.
    Meaningful only on svr3.  */
-#define TARGET_SVR3_SHLIB (target_flags & MASK_SVR3_SHLIB)
+#define TARGET_SVR3_SHLIB (target_flags & 040)
 
 /* Use IEEE floating point comparisons.  These handle correctly the cases
    where the result of a comparison is unordered.  Normally SIGFPE is
    generated in such cases, in which case this isn't needed.  */
-#define TARGET_IEEE_FP (target_flags & MASK_IEEE_FP)
+#define TARGET_IEEE_FP (target_flags & 0100)
 
 /* Functions that return a floating point value may return that value
    in the 387 FPU or in 386 integer registers.  If set, this flag causes
    the 387 to be used, which is compatible with most calling conventions. */
-#define TARGET_FLOAT_RETURNS_IN_80387 (target_flags & MASK_FLOAT_RETURNS)
-
-/* Disable generation of FP sin, cos and sqrt operations for 387.
-   This is because FreeBSD lacks these in the math-emulator-code */
-#define TARGET_NO_FANCY_MATH_387 (target_flags & MASK_NO_FANCY_MATH_387)
-
-/* Temporary switches for tuning code generation */
-
-/* Disable 32x32->64 bit multiplies that are used for long long multiplies
-   and division by constants, but sometimes cause reload problems.  */
-#define TARGET_NO_WIDE_MULTIPLY (target_flags & MASK_NO_WIDE_MULTIPLY)
-#define TARGET_WIDE_MULTIPLY (!TARGET_NO_WIDE_MULTIPLY)
-
-/* Debug GO_IF_LEGITIMATE_ADDRESS */
-#define TARGET_DEBUG_ADDR (target_flags & MASK_DEBUG_ADDR)
-
-/* Hack macros for tuning code generation */
-#define TARGET_MOVE	((target_flags & MASK_NO_MOVE) == 0)	/* Don't generate memory->memory */
-
-/* Specific hardware switches */
-#define TARGET_486	(target_flags & MASK_486)	/* 80486DX, 80486SX, 80486DX[24] */
-#define TARGET_386	(!TARGET_486) 			/* 80386 */
-
-#define TARGET_SWITCHES							\
-{ { "80387",			 MASK_80387 },				\
-  { "no-80387",			-MASK_80387 },				\
-  { "hard-float",		 MASK_80387 },				\
-  { "soft-float",		-MASK_80387 },				\
-  { "no-soft-float",		 MASK_80387 },				\
-  { "386",			-MASK_486 },				\
-  { "no-386",			 MASK_486 },				\
-  { "486",			 MASK_486 },				\
-  { "no-486",			-MASK_486 },				\
-  { "rtd",			 MASK_RTD },				\
-  { "no-rtd",			-MASK_RTD },				\
-  { "regparm",			 MASK_REGPARM },			\
-  { "no-regparm",		-MASK_REGPARM },			\
-  { "svr3-shlib",		 MASK_SVR3_SHLIB },			\
-  { "no-svr3-shlib",		-MASK_SVR3_SHLIB },			\
-  { "ieee-fp",			 MASK_IEEE_FP },			\
-  { "no-ieee-fp",		-MASK_IEEE_FP },			\
-  { "fp-ret-in-387",		 MASK_FLOAT_RETURNS },			\
-  { "no-fp-ret-in-387",		-MASK_FLOAT_RETURNS },			\
-  { "no-fancy-math-387",	 MASK_NO_FANCY_MATH_387 },		\
-  { "fancy-math-387",		-MASK_NO_FANCY_MATH_387 },		\
-  { "no-wide-multiply",		 MASK_NO_WIDE_MULTIPLY },		\
-  { "wide-multiply",		-MASK_NO_WIDE_MULTIPLY },		\
-  { "debug-addr",		 MASK_DEBUG_ADDR },			\
-  { "no-debug-addr",		-MASK_DEBUG_ADDR },			\
-  { "move",			-MASK_NO_MOVE },			\
-  { "no-move",			 MASK_NO_MOVE },			\
-  SUBTARGET_SWITCHES							\
-  { "", TARGET_DEFAULT | TARGET_CPU_DEFAULT}}
-
-/* This macro is similar to `TARGET_SWITCHES' but defines names of
-   command options that have values.  Its definition is an
-   initializer with a subgrouping for each command option.
-
-   Each subgrouping contains a string constant, that defines the
-   fixed part of the option name, and the address of a variable.  The
-   variable, type `char *', is set to the variable part of the given
-   option if the fixed part matches.  The actual option name is made
-   by appending `-m' to the specified name.  */
-#define TARGET_OPTIONS							\
-{ { "reg-alloc=", &i386_reg_alloc_order },				\
-  SUBTARGET_OPTIONS }
-
-/* Sometimes certain combinations of command options do not make
-   sense on a particular target machine.  You can define a macro
-   `OVERRIDE_OPTIONS' to take account of this.  This macro, if
-   defined, is executed once just after all the command options have
-   been parsed.
+#define TARGET_FLOAT_RETURNS_IN_80387 (target_flags & 0200)
 
-   Don't use this macro to turn on various extra optimizations for
-   `-O'.  That is what `OPTIMIZATION_OPTIONS' is for.  */
+/* Macro to define tables used to set the flags.
+   This is a list in braces of pairs in braces,
+   each pair being { "NAME", VALUE }
+   where VALUE is the bits to set or minus the bits to clear.
+   An empty string NAME is used to identify the default VALUE.  */
+
+/* intel1 */
+#define TARGET_486_SWITCH 2
+#define TARGET_486 (target_flags & TARGET_486_SWITCH)
+/* Compile code for a Pentium. intel1 */
+#define TARGET_PENTIUM_SWITCH 4
+#define TARGET_PENTIUM (target_flags & TARGET_PENTIUM_SWITCH)
+/* Compile code for an i386. intel1 */
+#define TARGET_386_SWITCH 0400
+#define TARGET_386 (target_flags & TARGET_386_SWITCH)
+/* Compile code for a Blend. intel1 */
+#define TARGET_BLEND_SWITCH 02000
+#define TARGET_BLEND (target_flags & TARGET_BLEND_SWITCH)
+
+#define TARGET_X ((TARGET_386) | (TARGET_486) | (TARGET_PENTIUM))
+#define USE_CPU ((TARGET_X) ? (TARGET_X) : TARGET_CPU_DEFAULT)
+
+#define TARGET_SWITCHES  \
+  { { "80387", 1},				\
+    { "no-80387", -1},				\
+    { "soft-float", -1},			\
+    { "no-soft-float", 1},			\
+    { "486", 2},				\
+    { "no-486", -2},				\
+    { "386", 0400},				\
+    { "pentium", 4},				\
+    { "blend", 02000},				\
+    { "rtd", 8},				\
+    { "no-rtd", -8},				\
+    { "regparm", 020},				\
+    { "no-regparm", -020},			\
+    { "svr3-shlib", 040},			\
+    { "no-svr3-shlib", -040},			\
+    { "ieee-fp", 0100},				\
+    { "no-ieee-fp", -0100},			\
+    { "fp-ret-in-387", 0200},			\
+    { "no-fp-ret-in-387", -0200},		\
+    SUBTARGET_SWITCHES                          \
+    { "", TARGET_DEFAULT }}
 
-#define OVERRIDE_OPTIONS override_options ()
-
-/* These are meant to be redefined in the host dependent files */
+/* This is meant to be redefined in the host dependent files */
 #define SUBTARGET_SWITCHES
-#define SUBTARGET_OPTIONS
 
 
+/* intel1 */
+
+#define SUB_TARGET_STRING \
+(TARGET_PENTIUM ? "Pentium"  : (TARGET_386 ? "Intel386" : "Intel486"))
+
+#define SUB_TARGET_VERSION fprintf (stderr, " [%s cpu] ", SUB_TARGET_STRING)
+
+
+/* Define this to change the optimizations performed by default.  */
+
+#define OPTIMIZATION_OPTIONS(LEVEL)	\
+optimization_options(LEVEL)
+
 /* target machine storage layout */
 
 /* Define for XFmode extended real floating point support.
    This will automatically cause REAL_ARITHMETIC to be defined.  */
 #define LONG_DOUBLE_TYPE_SIZE 96
-
+ 
 /* Define if you don't want extended real, but do want to use the
    software floating point emulator for REAL_ARITHMETIC and
    decimal <-> binary conversion. */
 /* #define REAL_ARITHMETIC */
 
+
 /* Define this if most significant byte of a word is the lowest numbered.  */
 /* That is true on the 80386.  */
 
@@ -250,6 +261,9 @@
    quantities, but these can be aligned on any 32-bit boundary.  */
 #define BIGGEST_ALIGNMENT 32
 
+/* intel1 - align DFmode constants and nonaggregates */
+#define ALIGN_DFmode (!TARGET_386)
+
 /* Set this non-zero if move instructions will actually fail to work
    when given unaligned data.  */
 #define STRICT_ALIGNMENT 0
@@ -275,6 +289,8 @@
    for details. */
 
 #define STACK_REGS
+/* intel1 */
+#define IS_STACK_MODE(mode) (mode==DFmode || mode==SFmode)
 
 /* Number of actual hardware registers.
    The hardware registers are assigned numbers for the compiler
@@ -312,44 +328,6 @@
 /*ax,dx,cx,bx,si,di,bp,sp,st,st1,st2,st3,st4,st5,st6,st7,arg*/ \
 {  1, 1, 1, 0, 0, 0, 0, 1, 1,  1,  1,  1,  1,  1,  1,  1,  1 }
 
-/* Order in which to allocate registers.  Each register must be
-   listed once, even those in FIXED_REGISTERS.  List frame pointer
-   late and fixed registers last.  Note that, in general, we prefer
-   registers listed in CALL_USED_REGISTERS, keeping the others
-   available for storage of persistent values.
-
-   Three different versions of REG_ALLOC_ORDER have been tried:
-
-   If the order is edx, ecx, eax, ... it produces a slightly faster compiler,
-   but slower code on simple functions returning values in eax.
-
-   If the order is eax, ecx, edx, ... it causes reload to abort when compiling
-   perl 4.036 due to not being able to create a DImode register (to hold a 2
-   word union).
-
-   If the order is eax, edx, ecx, ... it produces better code for simple
-   functions, and a slightly slower compiler.  Users complained about the code
-   generated by allocating edx first, so restore the 'natural' order of things. */
-
-#define REG_ALLOC_ORDER \
-/*ax,dx,cx,bx,si,di,bp,sp,st,st1,st2,st3,st4,st5,st6,st7,arg*/ \
-{  0, 1, 2, 3, 4, 5, 6, 7, 8,  9, 10, 11, 12, 13, 14, 15, 16 }
-
-/* A C statement (sans semicolon) to choose the order in which to
-   allocate hard registers for pseudo-registers local to a basic
-   block.
-
-   Store the desired register order in the array `reg_alloc_order'.
-   Element 0 should be the register to allocate first; element 1, the
-   next register; and so on.
-
-   The macro body should not assume anything about the contents of
-   `reg_alloc_order' before execution of the macro.
-
-   On most machines, it is not necessary to define this macro.  */
-
-#define ORDER_REGS_FOR_LOCAL_ALLOC order_regs_for_local_alloc ()
-
 /* Macro to conditionally modify fixed_regs/call_used_regs.  */
 #define CONDITIONAL_REGISTER_USAGE			\
   {							\
@@ -391,6 +369,9 @@
 /* The casts to int placate a compiler on a microvax,
    for cross-compiler testing.  */
 
+/* intel1 - added case of (REGNO)==16 (gbug12)*/
+/*   : (REGNO) == 16 ? 1                             \ */
+
 #define HARD_REGNO_MODE_OK(REGNO, MODE) \
   ((REGNO) < 2 ? 1						\
    : (REGNO) < 4 ? 1						\
@@ -462,27 +443,6 @@
 /* Place in which caller passes the structure value address.
    0 means push the value on the stack like an argument.  */
 #define STRUCT_VALUE 0
-
-/* A C expression which can inhibit the returning of certain function
-   values in registers, based on the type of value.  A nonzero value
-   says to return the function value in memory, just as large
-   structures are always returned.  Here TYPE will be a C expression
-   of type `tree', representing the data type of the value.
-
-   Note that values of mode `BLKmode' must be explicitly handled by
-   this macro.  Also, the option `-fpcc-struct-return' takes effect
-   regardless of this macro.  On most systems, it is possible to
-   leave the macro undefined; this causes a default definition to be
-   used, whose value is the constant 1 for `BLKmode' values, and 0
-   otherwise.
-
-   Do not use this macro to indicate that structures and unions
-   should always be returned in memory.  You should instead use
-   `DEFAULT_PCC_STRUCT_RETURN' to indicate this.  */
-
-#define RETURN_IN_MEMORY(TYPE) \
-  ((TYPE_MODE (TYPE) == BLKmode) || int_size_in_bytes (TYPE) > 12)
-
 
 /* Define the classes of registers for register constraints in the
    machine description.  Also define ranges of constants.
@@ -512,7 +472,6 @@
 {
   NO_REGS,
   AREG, DREG, CREG, BREG,
-  AD_REGS,			/* %eax/%edx for DImode */
   Q_REGS,			/* %eax %ebx %ecx %edx */
   SIREG, DIREG,
   INDEX_REGS,			/* %eax %ebx %ecx %edx %esi %edi %ebp */
@@ -531,7 +490,6 @@
 #define REG_CLASS_NAMES \
 {  "NO_REGS",				\
    "AREG", "DREG", "CREG", "BREG",	\
-   "AD_REGS",				\
    "Q_REGS",				\
    "SIREG", "DIREG",			\
    "INDEX_REGS",			\
@@ -547,10 +505,9 @@
 #define REG_CLASS_CONTENTS \
 {      0,							\
      0x1,    0x2,  0x4,	 0x8,	/* AREG, DREG, CREG, BREG */	\
-     0x3,			/* AD_REGS */			\
      0xf,			/* Q_REGS */			\
     0x10,   0x20,		/* SIREG, DIREG */		\
- 0x07f,				/* INDEX_REGS */		\
+ 0x1007f,			/* INDEX_REGS */		\
  0x100ff,			/* GENERAL_REGS */		\
   0x0100, 0x0200,		/* FP_TOP_REG, FP_SECOND_REG */	\
   0xff00,			/* FLOAT_REGS */		\
@@ -561,6 +518,7 @@
    reg number REGNO.  This could be a conditional expression
    or could index an array.  */
 
+extern enum reg_class regclass_map[FIRST_PSEUDO_REGISTER];
 #define REGNO_REG_CLASS(REGNO) (regclass_map[REGNO])
 
 /* When defined, the compiler allows registers explicitly used in the
@@ -618,9 +576,8 @@
    (C) == 'b' ? BREG :						\
    (C) == 'c' ? CREG :						\
    (C) == 'd' ? DREG :						\
-   (C) == 'A' ? AD_REGS :					\
    (C) == 'D' ? DIREG :						\
-   (C) == 'S' ? SIREG : NO_REGS)
+   (C) == 'S' ? SIREG : NO_REGS) /* intel1 changed to e from S */
 
 /* The letters I, J, K, L and M in a register constraint string
    can be used to stand for particular ranges of immediate operands.
@@ -632,6 +589,7 @@
    J is for DImode shifts.
    K and L are for an `andsi' optimization.
    M is for shifts that can be executed by the "lea" opcode.
+   O is for block moves intel1
    */
 
 #define CONST_OK_FOR_LETTER_P(VALUE, C)  \
@@ -640,6 +598,7 @@
    (C) == 'K' ? (VALUE) == 0xff :		\
    (C) == 'L' ? (VALUE) == 0xffff :		\
    (C) == 'M' ? (VALUE) >= 0 && (VALUE) <= 3 :	\
+   (C) == 'O' ? (VALUE) >= 0 && (VALUE) <= 32 :	\
    0)
 
 /* Similar, but for floating constants, and defining letters G and H.
@@ -692,33 +651,91 @@
 #define CLASS_MAX_NREGS(CLASS, MODE)	\
  (FLOAT_CLASS_P (CLASS) ? 1 :		\
   ((GET_MODE_SIZE (MODE) + UNITS_PER_WORD - 1) / UNITS_PER_WORD))
+
+
+/* A C statement (sans semicolon) to update the integer variable COST
+   based on the relationship between INSN that is dependent on
+   DEP_INSN through the dependence LINK.  The default is to make no
+   adjustment to COST.  */
+#define ADJUST_COST(insn,link,dep_insn,cost)				\
+  {									\
+    rtx next_inst;							\
+    if (GET_CODE (dep_insn) == CALL_INSN)				\
+      (cost) = 0;							\
+        if (GET_CODE (dep_insn) == INSN					\
+            && GET_CODE (PATTERN (dep_insn)) == SET			\
+            && GET_CODE (SET_DEST (PATTERN (dep_insn))) == REG		\
+            && GET_CODE (insn) == INSN					\
+            && GET_CODE (PATTERN (insn)) == SET				\
+            && !reg_overlap_mentioned_p (SET_DEST (PATTERN (dep_insn)),	\
+            	                         SET_SRC (PATTERN (insn))))	\
+          {								\
+            (cost) = 0;							\
+          }								\
+    if (GET_CODE (insn) == JUMP_INSN)					\
+      {									\
+        (cost) = 0;							\
+      }									\
+    if (TARGET_PENTIUM)							\
+      {									\
+        if (cost !=0 && is_fp_insn (insn) && is_fp_insn (dep_insn) 	\
+            && !is_fp_dest (dep_insn))					\
+          {								\
+            (cost) = 0;							\
+          }								\
+        if (agi_dependent (insn, dep_insn))				\
+          {								\
+            (cost) = 3;							\
+          }								\
+        else if (GET_CODE (insn) == INSN 				\
+                 && GET_CODE (PATTERN (insn)) == SET			\
+                 && SET_DEST (PATTERN (insn)) == cc0_rtx		\
+                 && (next_inst = next_nonnote_insn (insn))		\
+                 && GET_CODE (next_inst) == JUMP_INSN)			\
+          { /* compare probably paired with jump */			\
+            (cost) = 0;							\
+          }								\
+      }									\
+    else								\
+    if(!is_fp_dest (dep_insn))						\
+      {									\
+        if(!agi_dependent (insn, dep_insn))				\
+          (cost) = 0;							\
+         else if (TARGET_486)						\
+           (cost) = 2;							\
+      }									\
+    else								\
+    if(is_fp_store (insn) && is_fp_insn (dep_insn)			\
+       && NEXT_INSN (insn) && NEXT_INSN (NEXT_INSN (insn))		\
+       && NEXT_INSN (NEXT_INSN (NEXT_INSN (insn)))			\
+       && (GET_CODE (NEXT_INSN (insn)) == INSN)				\
+       && (GET_CODE (NEXT_INSN (NEXT_INSN (insn))) == JUMP_INSN)	\
+       && (GET_CODE (NEXT_INSN (NEXT_INSN (NEXT_INSN (insn)))) 		\
+            == NOTE)							\
+       && NOTE_LINE_NUMBER (NEXT_INSN (NEXT_INSN (NEXT_INSN (insn)))) 	\
+           == NOTE_INSN_LOOP_END)					\
+      {									\
+           (cost) = 3;							\
+      }									\
+  }									
 
-/* A C expression whose value is nonzero if pseudos that have been
-   assigned to registers of class CLASS would likely be spilled
-   because registers of CLASS are needed for spill registers.
-
-   The default value of this macro returns 1 if CLASS has exactly one
-   register and zero otherwise.  On most machines, this default
-   should be used.  Only define this macro to some other expression
-   if pseudo allocated by `local-alloc.c' end up in memory because
-   their hard registers were needed for spill regisers.  If this
-   macro returns nonzero for those classes, those pseudos will only
-   be allocated by `global.c', which knows how to reallocate the
-   pseudo to another register.  If there would not be another
-   register available for reallocation, you should not change the
-   definition of this macro since the only effect of such a
-   definition would be to slow down register allocation.  */
-
-#define CLASS_LIKELY_SPILLED_P(CLASS)					\
-  (((CLASS) == AREG)							\
-   || ((CLASS) == DREG)							\
-   || ((CLASS) == CREG)							\
-   || ((CLASS) == BREG)							\
-   || ((CLASS) == AD_REGS)						\
-   || ((CLASS) == SIREG)						\
-   || ((CLASS) == DIREG))
 
-
+#define ADJUST_BLOCKAGE(last_insn,insn,blockage)			\
+  {									\
+    if(is_fp_store (last_insn) && is_fp_insn (insn)			\
+       && NEXT_INSN (last_insn) && NEXT_INSN (NEXT_INSN (last_insn))	\
+       && NEXT_INSN (NEXT_INSN (NEXT_INSN (last_insn)))			\
+       && (GET_CODE (NEXT_INSN (last_insn)) == INSN)			\
+       && (GET_CODE (NEXT_INSN (NEXT_INSN (last_insn))) == JUMP_INSN)	\
+       && (GET_CODE (NEXT_INSN (NEXT_INSN (NEXT_INSN (last_insn)))) 	\
+            == NOTE)							\
+       && NOTE_LINE_NUMBER (NEXT_INSN (NEXT_INSN (NEXT_INSN (last_insn)))) 	\
+           == NOTE_INSN_LOOP_END)					\
+      {									\
+           (blockage) = 3;						\
+      }									\
+  }									
+
 /* Stack layout; function entry, exit and calling.  */
 
 /* Define this if pushing a word on the stack
@@ -889,102 +906,6 @@
     }									\
 }
 
-/* A C statement or compound statement to output to FILE some
-   assembler code to initialize basic-block profiling for the current
-   object module.  This code should call the subroutine
-   `__bb_init_func' once per object module, passing it as its sole
-   argument the address of a block allocated in the object module.
-
-   The name of the block is a local symbol made with this statement:
-
-	ASM_GENERATE_INTERNAL_LABEL (BUFFER, "LPBX", 0);
-
-   Of course, since you are writing the definition of
-   `ASM_GENERATE_INTERNAL_LABEL' as well as that of this macro, you
-   can take a short cut in the definition of this macro and use the
-   name that you know will result.
-
-   The first word of this block is a flag which will be nonzero if the
-   object module has already been initialized.  So test this word
-   first, and do not call `__bb_init_func' if the flag is nonzero.  */
-
-#undef	FUNCTION_BLOCK_PROFILER
-#define FUNCTION_BLOCK_PROFILER(STREAM, LABELNO)			\
-do									\
-  {									\
-    static int num_func = 0;						\
-    rtx xops[8];							\
-    char block_table[80], false_label[80];				\
-									\
-    ASM_GENERATE_INTERNAL_LABEL (block_table, "LPBX", 0);		\
-    ASM_GENERATE_INTERNAL_LABEL (false_label, "LPBZ", num_func);	\
-									\
-    xops[0] = const0_rtx;						\
-    xops[1] = gen_rtx (SYMBOL_REF, VOIDmode, block_table);		\
-    xops[2] = gen_rtx (MEM, Pmode, gen_rtx (SYMBOL_REF, VOIDmode, false_label)); \
-    xops[3] = gen_rtx (MEM, Pmode, gen_rtx (SYMBOL_REF, VOIDmode, "__bb_init_func")); \
-    xops[4] = gen_rtx (MEM, Pmode, xops[1]);				\
-    xops[5] = stack_pointer_rtx;					\
-    xops[6] = GEN_INT (4);						\
-    xops[7] = gen_rtx (REG, Pmode, 0);	/* eax */			\
-									\
-    CONSTANT_POOL_ADDRESS_P (xops[1]) = TRUE;				\
-    CONSTANT_POOL_ADDRESS_P (xops[2]) = TRUE;				\
-									\
-    output_asm_insn (AS2(cmp%L4,%0,%4), xops);				\
-    output_asm_insn (AS1(jne,%2), xops);				\
-									\
-    if (!flag_pic)							\
-      output_asm_insn (AS1(push%L1,%1), xops);				\
-    else								\
-      {									\
-	output_asm_insn (AS2 (lea%L7,%a1,%7), xops);			\
-	output_asm_insn (AS1 (push%L7,%7), xops);			\
-      }									\
-									\
-    output_asm_insn (AS1(call,%P3), xops);				\
-    output_asm_insn (AS2(add%L0,%6,%5), xops);				\
-    ASM_OUTPUT_INTERNAL_LABEL (STREAM, "LPBZ", num_func);		\
-    num_func++;								\
-  }									\
-while (0)
-
-
-/* A C statement or compound statement to increment the count
-   associated with the basic block number BLOCKNO.  Basic blocks are
-   numbered separately from zero within each compilation.  The count
-   associated with block number BLOCKNO is at index BLOCKNO in a
-   vector of words; the name of this array is a local symbol made
-   with this statement:
-
-	ASM_GENERATE_INTERNAL_LABEL (BUFFER, "LPBX", 2);
-
-   Of course, since you are writing the definition of
-   `ASM_GENERATE_INTERNAL_LABEL' as well as that of this macro, you
-   can take a short cut in the definition of this macro and use the
-   name that you know will result.  */
-
-#define BLOCK_PROFILER(STREAM, BLOCKNO)					\
-do									\
-  {									\
-    rtx xops[1], cnt_rtx;						\
-    char counts[80];							\
-									\
-    ASM_GENERATE_INTERNAL_LABEL (counts, "LPBX", 2);			\
-    cnt_rtx = gen_rtx (SYMBOL_REF, VOIDmode, counts);			\
-    SYMBOL_REF_FLAG (cnt_rtx) = TRUE;					\
-									\
-    if (BLOCKNO)							\
-      cnt_rtx = plus_constant (cnt_rtx, (BLOCKNO)*4);			\
-									\
-    if (flag_pic)							\
-      cnt_rtx = gen_rtx (PLUS, Pmode, pic_offset_table_rtx, cnt_rtx);	\
-									\
-    xops[0] = gen_rtx (MEM, SImode, cnt_rtx);				\
-    output_asm_insn (AS1(inc%L0,%0), xops);				\
-  }									\
-while (0)
-
 /* EXIT_IGNORE_STACK should be nonzero if, when returning from a function,
    the stack pointer does not matter.  The value is tested only in
    functions that have frame pointers.
@@ -1148,35 +1069,36 @@
    After reload, it makes no difference, since pseudo regs have
    been eliminated by then.  */
 
+#ifndef REG_OK_STRICT
+
+/* Nonzero if X is a hard reg that can be used as an index or if
+   it is a pseudo reg.  */
 
-/* Non strict versions, pseudos are ok */
-#define REG_OK_FOR_INDEX_NONSTRICT_P(X)					\
-  (REGNO (X) < STACK_POINTER_REGNUM					\
+#define REG_OK_FOR_INDEX_P(X) \
+  (REGNO (X) < STACK_POINTER_REGNUM \
    || REGNO (X) >= FIRST_PSEUDO_REGISTER)
 
-#define REG_OK_FOR_BASE_NONSTRICT_P(X)					\
-  (REGNO (X) <= STACK_POINTER_REGNUM					\
-   || REGNO (X) == ARG_POINTER_REGNUM					\
-   || REGNO (X) >= FIRST_PSEUDO_REGISTER)
+/* Nonzero if X is a hard reg that can be used as a base reg
+   of if it is a pseudo reg.  */
+  /* ?wfs */
+
+#define REG_OK_FOR_BASE_P(X) \
+  (REGNO (X) <= STACK_POINTER_REGNUM \
+   || REGNO (X) == ARG_POINTER_REGNUM \
+   || REGNO(X) >= FIRST_PSEUDO_REGISTER)
 
-#define REG_OK_FOR_STRREG_NONSTRICT_P(X)				\
+#define REG_OK_FOR_STRREG_P(X) \
   (REGNO (X) == 4 || REGNO (X) == 5 || REGNO (X) >= FIRST_PSEUDO_REGISTER)
 
-/* Strict versions, hard registers only */
-#define REG_OK_FOR_INDEX_STRICT_P(X) REGNO_OK_FOR_INDEX_P (REGNO (X))
-#define REG_OK_FOR_BASE_STRICT_P(X)  REGNO_OK_FOR_BASE_P (REGNO (X))
-#define REG_OK_FOR_STRREG_STRICT_P(X)					\
-  (REGNO_OK_FOR_DIREG_P (REGNO (X)) || REGNO_OK_FOR_SIREG_P (REGNO (X)))
+#else
 
-#ifndef REG_OK_STRICT
-#define REG_OK_FOR_INDEX_P(X)  REG_OK_FOR_INDEX_NONSTRICT_P(X)
-#define REG_OK_FOR_BASE_P(X)   REG_OK_FOR_BASE_NONSTRICT_P(X)
-#define REG_OK_FOR_STRREG_P(X) REG_OK_FOR_STRREG_NONSTRICT_P(X)
+/* Nonzero if X is a hard reg that can be used as an index.  */
+#define REG_OK_FOR_INDEX_P(X) REGNO_OK_FOR_INDEX_P (REGNO (X))
+/* Nonzero if X is a hard reg that can be used as a base reg.  */
+#define REG_OK_FOR_BASE_P(X) REGNO_OK_FOR_BASE_P (REGNO (X))
+#define REG_OK_FOR_STRREG_P(X) \
+  (REGNO_OK_FOR_DIREG_P (REGNO (X)) || REGNO_OK_FOR_SIREG_P (REGNO (X)))
 
-#else
-#define REG_OK_FOR_INDEX_P(X)  REG_OK_FOR_INDEX_STRICT_P(X)
-#define REG_OK_FOR_BASE_P(X)   REG_OK_FOR_BASE_STRICT_P(X)
-#define REG_OK_FOR_STRREG_P(X) REG_OK_FOR_STRREG_STRICT_P(X)
 #endif
 
 /* GO_IF_LEGITIMATE_ADDRESS recognizes an RTL expression
@@ -1202,22 +1124,62 @@
 
 #define LEGITIMATE_CONSTANT_P(X) 1
 
-#ifdef REG_OK_STRICT
-#define GO_IF_LEGITIMATE_ADDRESS(MODE, X, ADDR)				\
-{									\
-  if (legitimate_address_p (MODE, X, 1))				\
-    goto ADDR;								\
-}
+#define GO_IF_INDEXABLE_BASE(X, ADDR)	\
+ if (GET_CODE (X) == REG && REG_OK_FOR_BASE_P (X)) goto ADDR
 
-#else
-#define GO_IF_LEGITIMATE_ADDRESS(MODE, X, ADDR)				\
+#define LEGITIMATE_INDEX_REG_P(X)   \
+  (GET_CODE (X) == REG && REG_OK_FOR_INDEX_P (X))
+
+/* Return 1 if X is an index or an index times a scale.  */
+
+#define LEGITIMATE_INDEX_P(X)   \
+   (LEGITIMATE_INDEX_REG_P (X)				\
+    || (GET_CODE (X) == MULT				\
+	&& LEGITIMATE_INDEX_REG_P (XEXP (X, 0))		\
+	&& GET_CODE (XEXP (X, 1)) == CONST_INT		\
+	&& (INTVAL (XEXP (X, 1)) == 2			\
+	    || INTVAL (XEXP (X, 1)) == 4		\
+	    || INTVAL (XEXP (X, 1)) == 8)))
+
+/* Go to ADDR if X is an index term, a base reg, or a sum of those.  */
+
+#define GO_IF_INDEXING(X, ADDR)	\
+{ if (LEGITIMATE_INDEX_P (X)) goto ADDR;				\
+  GO_IF_INDEXABLE_BASE (X, ADDR);					\
+  if (GET_CODE (X) == PLUS && LEGITIMATE_INDEX_P (XEXP (X, 0)))		\
+    { GO_IF_INDEXABLE_BASE (XEXP (X, 1), ADDR); }			\
+  if (GET_CODE (X) == PLUS && LEGITIMATE_INDEX_P (XEXP (X, 1)))		\
+    { GO_IF_INDEXABLE_BASE (XEXP (X, 0), ADDR); } }
+
+/* We used to allow this, but it isn't ever used.
+   || ((GET_CODE (X) == POST_DEC || GET_CODE (X) == POST_INC)		\
+       && REG_P (XEXP (X, 0))						\
+       && REG_OK_FOR_STRREG_P (XEXP (X, 0)))				\
+*/
+
+#define GO_IF_LEGITIMATE_ADDRESS(MODE, X, ADDR)	\
 {									\
-  if (legitimate_address_p (MODE, X, 0))				\
+  if (CONSTANT_ADDRESS_P (X)						\
+      && (! flag_pic || LEGITIMATE_PIC_OPERAND_P (X)))			\
     goto ADDR;								\
+  GO_IF_INDEXING (X, ADDR);						\
+  if (GET_CODE (X) == PLUS && CONSTANT_ADDRESS_P (XEXP (X, 1)))		\
+    {									\
+      rtx x0 = XEXP (X, 0);						\
+      if (! flag_pic || ! SYMBOLIC_CONST (XEXP (X, 1)))			\
+	{ GO_IF_INDEXING (x0, ADDR); }					\
+      else if (x0 == pic_offset_table_rtx)				\
+	goto ADDR;							\
+      else if (GET_CODE (x0) == PLUS)					\
+	{								\
+	  if (XEXP (x0, 0) == pic_offset_table_rtx)			\
+	    { GO_IF_INDEXABLE_BASE (XEXP (x0, 1), ADDR); }		\
+	  if (XEXP (x0, 1) == pic_offset_table_rtx)			\
+	    { GO_IF_INDEXABLE_BASE (XEXP (x0, 0), ADDR); }		\
+	}								\
+    }									\
 }
 
-#endif
-
 /* Try machine-dependent ways of modifying an illegitimate address
    to be legitimate.  If we find one, return the new, valid address.
    This macro is used in only one place: `memory_address' in explow.c.
